
import RPi.GPIO as GPIO
import time

GPIO.setmode(GPIO.BCM)

GPIO.setup(21, GPIO.OUT)
GPIO.setup(27, GPIO.IN,pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(25, GPIO.IN,pull_up_down=GPIO.PUD_DOWN)

DISPENSER_1_GPIO = 20
DISPENSER_2_GPIO = 19
TURNTABLE_GPIO = 21
REED_1_GPIO = 27
REED_2_GPIO = 25                                             

GPIO.setup(DISPENSER_1_GPIO, GPIO.OUT)
GPIO.setup(DISPENSER_2_GPIO, GPIO.OUT)

disp_1_p = GPIO.PWM(DISPENSER_1_GPIO, 47)
disp_1_p.start(0)


disp_2_p = GPIO.PWM(DISPENSER_2_GPIO, 47)
disp_2_p.start(0)



def set_speed(pulse_time):
        global p
        valley = 20 #time between each pulse for motor servo control (msec)
        peak = pulse_time
    
        freq = 1/((valley+peak)*0.001)
        duty = peak/(valley+peak)*100

        p.ChangeFrequency(freq)
        p.ChangeDutyCycle(duty)

def set_position(pulse_time, p):
        valley = 20 #time between each pulse for motor servo control (msec)
        peak = pulse_time
    
        freq = 1/((valley+peak)*0.001)
        duty = peak/(valley+peak)*100

        p.ChangeFrequency(freq)
        p.ChangeDutyCycle(duty)

def dispense(percentage, disp_p):
	set_position(1, disp_p)
	
	pos = .7
	percentage = percentage - 6
	set_position(.7, disp_p)
	if percentage > 0:
		time.sleep(.066*percentage)
		
	while(pos < 1):
		pos += .05
		set_position(pos, disp_p)
		time.sleep(.15)
	set_position(0, disp_p)		
	time.sleep(10)



p = GPIO.PWM(21, 47)
p.start(0)
set_position(1, disp_1_p)
set_position(1, disp_2_p)
set_speed(1.4)
cntr = 0
try:
	while True:
		
		while GPIO.input(27):
#			print('27')
			cntr += 1
			if cntr >= 100:
				set_speed(1.45)
				time.sleep(.4)
				set_speed(0)
				dispense(20, disp_1_p)
				time.sleep(2)
				set_speed(1.4)
				time.sleep(.4)
				print('triggered')
				break
		cntr = 0

		while GPIO.input(25):
			#print('25')
			cntr += 1
			if cntr >= 100:
				set_speed(1.45)
				time.sleep(.4)
				set_speed(0)
				dispense(20, disp_2_p)
				time.sleep(2)
				set_speed(1.4)
				time.sleep(.4)
				print('triggered')
				break
		cntr = 0			
except KeyboardInterrupt:
	p.stop()
	GPIO.cleanup()
	quit()
