
import RPi.GPIO as GPIO
import time
import sys

GPIO.setmode(GPIO.BCM)

DISPENSER_1_GPIO = 20
DISPENSER_2_GPIO = 19
TURNTABLE_GPIO = 21
REED_1_GPIO = 27
REED_2_GPIO = 25                                             

GPIO.setup(TURNTABLE_GPIO, GPIO.OUT)
GPIO.setup(REED_1_GPIO, GPIO.IN)
GPIO.setup(REED_2_GPIO, GPIO.IN)
GPIO.setup(DISPENSER_1_GPIO, GPIO.OUT)
GPIO.setup(DISPENSER_2_GPIO, GPIO.OUT)

turn_p = GPIO.PWM(TURNTABLE_GPIO, 47)
turn_p.start(0)

disp_1_p = GPIO.PWM(DISPENSER_1_GPIO, 47)
disp_1_p.start(0)

disp_2_p = GPIO.PWM(DISPENSER_2_GPIO, 47)
disp_2_p.start(0)

def set_speed(pulse_time, p):
        valley = 20 #time between each pulse for motor servo control (msec)
        peak = pulse_time
    
        freq = 1/((valley+peak)*0.001)
        duty = peak/(valley+peak)*100

        p.ChangeFrequency(freq)
        p.ChangeDutyCycle(duty)

def set_position(pulse_time, p):
        valley = 20 #time between each pulse for motor servo control (msec)
        peak = pulse_time
    
        freq = 1/((valley+peak)*0.001)
        duty = peak/(valley+peak)*100

        p.ChangeFrequency(freq)
        p.ChangeDutyCycle(duty)

def dispense(disp_p):
	set_position(1.5, disp_p)
	time.sleep(.5)
	set_position(2.5, disp_p)
	time.sleep(.8)
	set_position(1.5, disp_p)
	time.sleep(2)

time.sleep(.25)
set_speed(1.4, turn_p)
time.sleep(.75)

cntr = 0

TARGET_REED = REED_2_GPIO


while True:
	if GPIO.input(TARGET_REED) and cntr < 1000:
		cntr = cntr + 1
		#print "wow"
	
	elif cntr >= 1000:
		set_speed(0, turn_p)
		print "cool"
		
		if(TARGET_REED == REED_1_GPIO):
			dispense(disp_1_p)
			TARGET_REED = REED_2_GPIO
			set_speed(1.4, turn_p)
			cntr = 0
			
		else:
			dispense(disp_2_p)
			TARGET_REED = REED_1_GPIO
			set_speed(1.4, turn_p)
			cntr = 0
	
	else:
		#print "no"
		cntr = 0

print "bye"
disp_1_p.stop()
disp_2_p.stop()
turn_p.stop()
GPIO.cleanup()
quit()
			

